package be.iminds.ilabt.jfed.experimenter_gui.slice.espec.view;

import be.iminds.ilabt.jfed.experimenter_gui.slice.espec.model.ESpecLogModel;
import be.iminds.ilabt.jfed.experimenter_gui.slice.espec.model.ESpecStateItem;
import javafx.application.Platform;
import javafx.collections.ListChangeListener;
import javafx.collections.ObservableList;
import javafx.scene.control.*;
import javafx.scene.layout.HBox;
import javafx.scene.layout.Pane;

import javax.annotation.Nonnull;


public class ESpecStateList extends ScrollPane {
    private final Pane contentPane;

    public ESpecStateList(ESpecLogModel eSpecLogModel) {
        this.contentPane = new HBox();
        setContent(contentPane);

        eSpecLogModel.geteSpecStateItems().addListener((ListChangeListener<ESpecStateItem>) c -> {
            while (c.next()) {
                if (c.wasAdded()) {
                    for (ESpecStateItem i : c.getAddedSubList())
                        addESpecStateItem(i);
                }
            }
        });
    }

    public void addESpecStateItem(@Nonnull ESpecStateItem eSpecStateItem) {
        Platform.runLater(() -> {
            contentPane.getChildren().add(new ESpecStateButton(eSpecStateItem));
        });
    }
}
